<?php defined('SYSPATH') or die('No direct script access.');

class Model_Grades extends Model
{
    public static function create() {
        return new self();
    }

    public function getGrades() {
        $sql = "CALL `GetGrades`();";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function common() {
        $grades = $this->GetGrades();
        $list = array();

        foreach ($grades as $row) {
            if ($row['Degree'] == 'bachelor' || $row['Degree'] == 'specialist')
                $row['Title'] = 'Курс ' . $row['Num'];
            if ($row['Degree'] == 'master')
                $row['Title'] = 'Магистратура ' . $row['Num'];
            $list[] = $row;
        }

        return new DataArray_Result($list);
    }

    public static function getDegreeTitle($degree) {
        switch ($degree) {
            case 'bachelor':
                return 'Бакалавриат';
            case 'specialist':
                return 'Специалитет';
            case 'master':
                return 'Магистратура';
            default:
                return $degree;
        }
    }

    public function structured() {
        $grades = $this->common()->asArray();
        $list = array();
        $degree = 'null';
        $i = 0;

        foreach ($grades as $row) {
            if ($degree != $row['Degree']) {
                $degree = $row['Degree'];
                $i++;
            }

            $list[$i]['Title'] = self::getDegreeTitle($row['Degree']);
            $list[$i]['Grades'][] = $row;
        }

        return new DataArray_Result($list);
    }
}
